// ChildView.cpp : implementation of the CChildView class
//

#include "stdafx.h"
#include "TestDD.h"
#include "ChildView.h"
#include <windowsx.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CChildView

CChildView::CChildView()
{
}

CChildView::~CChildView()
{
}


BEGIN_MESSAGE_MAP(CChildView, CWnd)
ON_WM_PAINT()
ON_COMMAND(ID_TEST_TESTPARAMETERBINDOFFSETSEQUENTIAL, OnTestTestparameterbindoffsetsequential)
ON_UPDATE_COMMAND_UI(ID_TEST_TESTPARAMETERBINDOFFSETSEQUENTIAL, OnUpdateTestTestparameterbindoffsetsequential)
ON_COMMAND(ID_TESTTABLETYPES, OnTesttabletypes)
ON_UPDATE_COMMAND_UI(ID_TESTTABLETYPES, OnUpdateTesttabletypes)
ON_WM_CREATE()
ON_COMMAND(ID_TEST_TESTPARAMETERBINDOFFSETINSERT, OnTestTestparameterbindoffsetinsert)
ON_UPDATE_COMMAND_UI(ID_TEST_TESTPARAMETERBINDOFFSETINSERT, OnUpdateTestTestparameterbindoffsetinsert)
ON_COMMAND(ID_TEST_TESTWITHOUTPARAMETERBINDOFFSET, OnTestTestwithoutparameterbindoffset)
ON_UPDATE_COMMAND_UI(ID_TEST_TESTWITHOUTPARAMETERBINDOFFSET, OnUpdateTestTestwithoutparameterbindoffset)
ON_COMMAND(ID_TEST_TESTPARAMETERLONGERROR, OnTestTestparameterlongerror)
ON_UPDATE_COMMAND_UI(ID_TEST_TESTPARAMETERLONGERROR, OnUpdateTestTestparameterlongerror)
ON_COMMAND(ID_TEST_TESTPARAMETERLONGERRORNOBINDOFFSETPOINTER, OnTestTestparameterlongerrornobindoffsetpointer)
ON_UPDATE_COMMAND_UI(ID_TEST_TESTPARAMETERLONGERRORNOBINDOFFSETPOINTER, OnUpdateTestTestparameterlongerrornobindoffsetpointer)

ON_COMMAND(ID_TESTSQLTABLESWITHROWOFFSETPOINTER, OnTestSQLTablesWithRowoffsetpointer)
ON_UPDATE_COMMAND_UI(ID_TESTSQLTABLESWITHROWOFFSETPOINTER, OnUpdateTestSQLTablesWithRowOffsetPointer)

ON_COMMAND(ID_TEST_TESTSQLTABLESWITHOUTROWOFFSETPOINTER, OnTestSQLTablesWithoutrowoffsetpointer)
ON_UPDATE_COMMAND_UI(ID_TEST_TESTSQLTABLESWITHOUTROWOFFSETPOINTER, OnUpdateTestSQLTtablesWithoutrowoffsetpointer)
ON_COMMAND(ID_TEST_TESTSQLTABLEMULTI, OnTestTestsqltablemulti)
ON_UPDATE_COMMAND_UI(ID_TEST_TESTSQLTABLEMULTI, OnUpdateTestTestsqltablemulti)
ON_COMMAND(ID_TEST_RUNTEST, OnTestRuntest)
ON_UPDATE_COMMAND_UI(ID_TEST_RUNTEST, OnUpdateTestRuntest)
ON_COMMAND(ID_TEST_2, OnTest2)
ON_UPDATE_COMMAND_UI(ID_TEST_2, OnUpdateTest2)
END_MESSAGE_MAP()



// CChildView message handlers

BOOL CChildView::PreCreateWindow(CREATESTRUCT& cs) 
{
	if (!CWnd::PreCreateWindow(cs))
		return FALSE;

	cs.dwExStyle |= WS_EX_CLIENTEDGE;
	cs.style &= ~WS_BORDER;
	cs.lpszClass = AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS, 
		::LoadCursor(NULL, IDC_ARROW), reinterpret_cast<HBRUSH>(COLOR_WINDOW+1), NULL);

	return TRUE;
}

void CChildView::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here
	
	// Do not call CWnd::OnPaint() for painting messages
}


#define RC_SUCCESS(x)	((x) == SQL_SUCCESS || \
				        (x)  == SQL_SUCCESS_WITH_INFO)


RETCODE CChildView::DiagSQLError( SQLHENV  henv, 
                              SQLHDBC  hdbc, 
                              SQLHSTMT hstmt,
                              const SQLRETURN rc,
                              const char *ROUTINE,
                              const char *szContext ) {

    SQLCHAR  szSQLState[ 20 ];
    UCHAR    szMessageText[ 2000 + 1 ];
    const char *szCaption = "";
    SDWORD   nNativeError;
    SWORD    cb;

    if ( rc == SQL_SUCCESS )
        return TRUE;

    szSQLState[0]    = '\0';
    szMessageText[0] = '\0';

    SQLError( henv, hdbc, hstmt, szSQLState, &nNativeError, szMessageText,
        sizeof( szMessageText ), &cb );

    CString sText;

    sText.Format( "SQLState: %s\n"
        "Native Error: %d\n%s", szSQLState, nNativeError, szMessageText );
        
    //AfxMessageBox( sText, MB_OK, 0 );
    MessageBox( sText, ROUTINE, MB_OK );

    return SQL_SUCCESS;
}


SQLRETURN CChildView::Connect( SQLHENV  &henv,
                               SQLHDBC  &hdbc,
                               const char *szConnect ) {

    ASSERT( szConnect != NULL && *szConnect );
    ASSERT( henv == NULL );
    ASSERT( hdbc == NULL );

    // connect to the database

    SQLRETURN rc = SQLAllocHandle( SQL_HANDLE_ENV,
                                   SQL_NULL_HANDLE,
                                   &henv );

    if ( !RC_SUCCESS( rc ) )
        return rc;

    // declare the odbc version to work with
    rc = SQLSetEnvAttr( henv,
                        SQL_ATTR_ODBC_VERSION, (SQLPOINTER ) SQL_OV_ODBC3, NULL );

    if ( !RC_SUCCESS( rc ) )
        return rc;

    // allocate connection handle

    rc = SQLAllocHandle( SQL_HANDLE_DBC,
                         henv,
                         &hdbc );

    if ( !RC_SUCCESS( rc ) )
        return rc;

    // attempt connection
    SQLSMALLINT cbConnStrOut;
    //SQLINTEGER	cbConnStrOut;
    const int   cbConnStrOutMax = 1024;
    char        szConnStrOut[ cbConnStrOutMax + 1 ];
    
    rc = SQLDriverConnect( hdbc, 
                           AfxGetApp()->GetMainWnd()->GetSafeHwnd(), // hwnd,
                           ( SQLCHAR * ) szConnect, 
                           ( SQLSMALLINT ) strlen( szConnect ),
                           ( SQLCHAR * ) szConnStrOut, 
						   cbConnStrOutMax, 
						   &cbConnStrOut,
                           SQL_DRIVER_COMPLETE /*SQL_DRIVER_NOPROMPT*/);

    if ( !RC_SUCCESS( rc ) ) {

        // done by caller
        //SQLFreeHandle( SQL_HANDLE_DBC, m_hdbc );

        //SQLFreeHandle( SQL_HANDLE_ENV, m_henv );

        return rc;
    }

    // connected

    return rc;
}


SQLRETURN CChildView::Disconnect( SQLHENV  &henv,
                                  SQLHDBC  &hdbc) {

    ASSERT( henv != NULL );
    ASSERT( hdbc != NULL );

    SQLRETURN rc = SQLDisconnect( hdbc );

    if ( !RC_SUCCESS( rc ) )
        return rc;

    rc = SQLFreeHandle( SQL_HANDLE_DBC, hdbc );
    hdbc = NULL;

    rc = SQLFreeHandle( SQL_HANDLE_ENV, henv );
    henv = NULL;

    return rc;
}


void CChildView::OnTestTestparameterbindoffsetsequential() {

    SQLHENV     henv = NULL;    
    SQLHDBC     hdbc = NULL;
    SQLHSTMT    hstmt = NULL;

    // to do: substitute your database connection info below
    const char *szConnect = "DSN=myodbcdatasourcename;UID=myuserid;PWD=mypassword";

    ASSERT( szConnect != NULL && *szConnect );

    SQLRETURN rc = Connect( henv, hdbc, szConnect );

    if ( RC_SUCCESS( rc ) ) {

        // connected

        rc = TestBindOffset( henv, hdbc, hstmt );
    }

    if ( !RC_SUCCESS( rc ) ) {

        DiagSQLError( henv, hdbc, hstmt, rc, "", "" );
    }

    if ( hdbc != NULL )
        Disconnect( henv, hdbc );

    if ( henv != NULL )
        SQLFreeHandle( SQL_HANDLE_ENV, henv );
}


void CChildView::OnUpdateTestTestparameterbindoffsetsequential(CCmdUI *pCmdUI) {

    pCmdUI->Enable( TRUE );
}


void CChildView::OnTesttabletypes() {

    SQLHENV     henv = NULL;    
    SQLHDBC     hdbc = NULL;
    SQLHSTMT    hstmt = NULL;

    m_lb.ResetContent();

    // to do: substitute your database connection info below
    //ASSERT( FALSE );
    const char *szConnect = "DSN=ants;UID=SYSTEM;PWD=SYSTEM";


    ASSERT( szConnect != NULL && *szConnect );

    SQLRETURN rc = Connect( henv, hdbc, szConnect );

    if ( rc == SQL_SUCCESS_WITH_INFO )
        DiagSQLError( henv, hdbc, hstmt, rc, "", "" );

    if ( RC_SUCCESS( rc ) ) {

        // connected

        DWORD cRow = 0;
        rc = TestSQLTables( henv, hdbc, 
                            "", // catalog
                            "", // schema
                            "", // table name
                            SQL_ALL_TABLE_TYPES,
                            cRow );
    }

    if ( !RC_SUCCESS( rc ) ) {

        DiagSQLError( henv, hdbc, hstmt, rc, "", "" );
    }

    if ( hdbc != NULL )
        Disconnect( henv, hdbc );

    if ( henv != NULL )
        SQLFreeHandle( SQL_HANDLE_ENV, henv );
}


void CChildView::TestSQLTables( const bool bParamBindOffset ) {

    SQLHENV     henv = NULL;    
    SQLHDBC     hdbc = NULL;
    SQLHSTMT    hstmt = NULL;

    // to do: substitute your database connection info below
    //ASSERT( FALSE );
    const char *szConnect = "DSN=RDMServer;UID=admin;PWD=secret";


    ASSERT( szConnect != NULL && *szConnect );

    SQLRETURN rc = Connect( henv, hdbc, szConnect );

    if ( rc == SQL_SUCCESS_WITH_INFO )
        DiagSQLError( henv, hdbc, hstmt, rc, "", "" );
	else if ( !RC_SUCCESS( rc ) ) {
		DiagSQLError( henv, hdbc, hstmt, rc, "", "" );
		return;
	}

    rc = SetAutoCommit( hdbc, false );

    if ( !RC_SUCCESS( rc ) )
        DiagSQLError( henv, hdbc, hstmt, rc, "", "" );



    if ( RC_SUCCESS( rc ) ) {

        // connected
		const size_t cRepeat = 20;

		for ( size_t i = 0; i < cRepeat; ++i ) {

			DWORD cRow = 0;
			rc = TestSQLTables( henv, hdbc,
								"", // catalog
								"", // schema
								"", // table name
								"", // table types,
								cRow,
								bParamBindOffset );

			if ( !RC_SUCCESS( rc ) ) {

				DiagSQLError( henv, hdbc, hstmt, rc, "", "" );
				break;
			}
		}
    }

    if ( hdbc != NULL )
        Disconnect( henv, hdbc );

    if ( henv != NULL )
        SQLFreeHandle( SQL_HANDLE_ENV, henv );
}


void CChildView::TestSQLTablesMT() {

	const TCHAR *ROUTINE = _T("TestSQLTablesMT");

    SQLHENV     henv = NULL;    
    SQLHDBC     hdbc = NULL;
    SQLHSTMT    hstmt = NULL;

    // to do: substitute your database connection info below
	const char *szConnect = "DSN=sqlite3";
    
    ASSERT( szConnect != NULL && *szConnect );

    SQLRETURN rc = Connect( henv, hdbc, szConnect );

    if ( rc == SQL_SUCCESS_WITH_INFO )
        DiagSQLError( henv, hdbc, hstmt, rc, "", "" );
	else if ( !RC_SUCCESS( rc ) ) {

		DiagSQLError( henv, hdbc, hstmt, rc, "", "" );
		return;
	}

    rc = SetAutoCommit( hdbc, false );

    if ( !RC_SUCCESS( rc ) )
        DiagSQLError( henv, hdbc, hstmt, rc, "", "" );

    // maximum number of active statements on a connection
    SQLUSMALLINT nMaxConcurrentActivities;

    rc = SQLGetInfo( hdbc, SQL_MAX_CONCURRENT_ACTIVITIES, 
                        &nMaxConcurrentActivities, NULL, NULL );

    if ( !RC_SUCCESS( rc ) ) {

        DiagSQLError( henv, hdbc, hstmt, rc, "", "" );
    }

    // no limit
    ASSERT( nMaxConcurrentActivities == 0 );

	SQLUINTEGER	nSQLAttrTxnIsolation;

	rc = SQLGetConnectAttr( hdbc, 
						    SQL_ATTR_TXN_ISOLATION,
						    &nSQLAttrTxnIsolation,
						    SQL_IS_POINTER, 
						    NULL );

    //const size_t COUNT_THREAD = 1;
    const size_t COUNT_THREAD = 64;
    CWinThread *pAThread[COUNT_THREAD];

	ASSERT( COUNT_THREAD <= MAXIMUM_WAIT_OBJECTS );

    for ( size_t i = 0; i < COUNT_THREAD; ++i ) {

        pAThread[i] = NULL;
    }


    if ( RC_SUCCESS( rc ) ) {

        // connected

        TEST_MT param;

        param.henv  = henv;
        param.hdbc  = hdbc;
        param.pView = this;

        for ( UINT i = 0; i < COUNT_THREAD; ++i ) {

            pAThread[i] = new CWinThread( TestSQLAllocStmtMTProc,
                                         ( LPVOID ) &param );

            ASSERT( pAThread[i] != NULL );
    
            if ( !CreateThreadSuspend( pAThread[i], false ) ) {

                AfxMessageBox( "Failed to create sort worker thread", 
                               MB_OK, 0 );
                break;
            }
        }

        vector< HANDLE > vHandle;

        for ( size_t i = 0; i < COUNT_THREAD; ++i ) {

            pAThread[i]->ResumeThread();

            vHandle.push_back( pAThread[i]->m_hThread );
        }

        DWORD dwResult = WaitForMultipleObjects( (DWORD) vHandle.size(), 
													&vHandle[0], TRUE, INFINITE );

		if ( dwResult == WAIT_FAILED ) {

			GetLastError( "WaitForMultipleObjects", ROUTINE );
		}

        for ( size_t i = 0; i < COUNT_THREAD; ++i ) {

            if ( pAThread[i] != NULL )
                delete pAThread[i];
        }
    }


    //if ( !RC_SUCCESS( rc ) ) {

    //    DiagSQLError( henv, hdbc, hstmt, rc, "", "" );
    //}

    if ( hdbc != NULL )
        Disconnect( henv, hdbc );

    if ( henv != NULL )
        SQLFreeHandle( SQL_HANDLE_ENV, henv );

	MessageBox( "Test Success", ROUTINE, MB_OK );
}


void CChildView::OnUpdateTesttabletypes(CCmdUI *pCmdUI) {

    pCmdUI->Enable( TRUE );
}



SQLRETURN CChildView::TestBindOffset( SQLHENV  &henv,
                                SQLHDBC  &hdbc,
                                SQLHSTMT &hstmt ) {

    ASSERT( henv != NULL );
    ASSERT( hdbc != NULL );
    ASSERT( hstmt != NULL );


    const UINT ROW_COUNT = 500;
    vector< BUF >   vRow( ROW_COUNT );   // our row buffer

    // additonal test that fails is when buffer gets moved on reallocations and
    // the parameter is not rebound
    // as long as the result of adding the bound buffer parameter address and 
    // offset pointer is valid the bound parameter buffer value and indicator
    // references can be invalid

    // get a the first row of the buffer so we can use it to bind the parameter
    BUF *pBaseRow = &vRow[0];
    
    // parameter bind offset
    SQLUINTEGER     m_nParamBindOffset = 0;

    const char *szSQL = "select 1 where 'Testing' = ? ";

    SQLRETURN rc = SQLAllocStmt( hdbc, &hstmt );

    if ( !RC_SUCCESS( rc ) )
        return rc;

    // bind the parameter
    rc = ::SQLBindParameter( hstmt, 
                             1,    // one-based
				             SQL_PARAM_INPUT, 
                             SQL_C_CHAR,   // nValueType,
				             SQL_VARCHAR,   // ParameterType, 
                             sizeof( pBaseRow->description), // cbColumnSize
				             0,             // DecimalDigits 
                             pBaseRow->description,   // pBuffer, 
                             sizeof( pBaseRow->description ), // nBufferLength,
				             &pBaseRow->descriptionIND ); // StrLen_or_IndPtr

    if ( !RC_SUCCESS( rc ) )
        return rc;

    // enable param binding offsets use
    rc = ::SQLSetStmtAttr( hstmt, 
                           SQL_ATTR_PARAM_BIND_OFFSET_PTR, 
                           &m_nParamBindOffset,
                           SQL_IS_POINTER );

    if ( !RC_SUCCESS( rc ) )
        return rc;


    // if you execute the statement sequentially from the start of the buffer
    // then no crash later when executing the statement on a row in the middle
    // or end of the buffer

    //// execute the statement sequentially
    //for ( UINT nRow = 0; nRow < vRow.size(); ++nRow ) {

    //    BUF *pRow = &vRow[nRow];

    //    m_nParamBindOffset = ( SQLUINTEGER ) 
    //        ( (intptr_t ) pRow - (intptr_t ) pBaseRow );

    //    rc = SQLExecDirect( m_hstmt,
    //                        (SQLCHAR *) szSQL,
    //                        ( SQLINTEGER ) strlen( szSQL ) );

    //    ASSERT( RC_SUCCESS( rc ) );

    //    if ( RC_SUCCESS( rc ) ) {

    //        rc = ::SQLFetch( m_hstmt );

    //        ASSERT( rc == SQL_NO_DATA_FOUND );

    //        // done with the resultset, close it
    //        if ( rc == SQL_NO_DATA_FOUND )
    //            rc = ::SQLFreeStmt( m_hstmt, SQL_CLOSE );
    //    }
    //}

    // execute statement in middle of buffer or at or just before the end WITHOUT
    // first executing the statement sequentially on all the buffer rows starting
    // from the begining of buffer results in driver CRASH
    UINT nRow2 = 450;
    ASSERT( nRow2 < vRow.size() );

    BUF *pRow = &vRow[nRow2];

    m_nParamBindOffset = ( SQLUINTEGER ) 
        ( (intptr_t ) pRow - (intptr_t ) pBaseRow );

    rc = SQLExecDirect( hstmt,
                        (SQLCHAR *) szSQL,
                        ( SQLINTEGER ) strlen( szSQL ) );

    ASSERT( RC_SUCCESS( rc ) );

    if ( RC_SUCCESS( rc ) ) {

        rc = ::SQLFetch( hstmt );

        ASSERT( rc == SQL_NO_DATA_FOUND );

        // done with the resultset, close it
        if ( rc == SQL_NO_DATA_FOUND )
            rc = ::SQLFreeStmt( hstmt, SQL_CLOSE );
    }


    ::SQLFreeStmt( hstmt, SQL_DROP );
    hstmt = NULL;

    // disconnect done by caller

    return SQL_SUCCESS;
}


SQLRETURN CChildView::TestBindParamOffsetPtrInsert( SQLHENV  &henv,
                                                    SQLHDBC  &hdbc,
                                                    SQLHSTMT &hstmt ) {

    ASSERT( henv != NULL );
    ASSERT( hdbc != NULL );
    ASSERT( hstmt == NULL );


    const UINT ROW_COUNT = 500;
    vector< BUF >   vRow( ROW_COUNT );   // our row buffer

    // get a the first row of the buffer so we can use it to bind the parameter
    BUF *pBaseRow = &vRow[0];
    
    // parameter bind offset
    SQLUINTEGER     m_nParamBindOffset = 0;

    // table ddl
/*
CREATE TABLE "test_param_offset"(
 "num" INTEGER NOT NULL ,
 "description" CHAR(100) CASE 
);
CREATE INDEX "PK_TEST_PARAM_OFFSET" ON "test_param_offset"("num");
*/
    const char *szSQL = "insert into test_param_offset values ( ?, ? )";

    SQLRETURN rc = SQLAllocStmt( hdbc, &hstmt );

    if ( !RC_SUCCESS( rc ) )
        return rc;

    // bind the parameter
    rc = ::SQLBindParameter( hstmt, 
                             1,    // one-based
				             SQL_PARAM_INPUT, 
                             SQL_C_LONG,   // nValueType,
				             SQL_INTEGER,   // ParameterType, 
                             sizeof( pBaseRow->num), // cbColumnSize
				             0,             // DecimalDigits 
                             &pBaseRow->num,   // pBuffer, 
                             sizeof( pBaseRow->num ), // nBufferLength,
				             &pBaseRow->numIND ); // StrLen_or_IndPtr

    if ( !RC_SUCCESS( rc ) )
        return rc;

    // bind the parameter
    rc = ::SQLBindParameter( hstmt, 
                             2,    // one-based
				             SQL_PARAM_INPUT, 
                             SQL_C_CHAR,   // nValueType,
				             SQL_VARCHAR,   // ParameterType, 
                             sizeof( pBaseRow->description), // cbColumnSize
				             0,             // DecimalDigits 
                             pBaseRow->description,   // pBuffer, 
                             sizeof( pBaseRow->description ), // nBufferLength,
				             &pBaseRow->descriptionIND ); // StrLen_or_IndPtr

    if ( !RC_SUCCESS( rc ) )
        return rc;


    // enable param binding offsets use
    rc = ::SQLSetStmtAttr( hstmt, 
                           SQL_ATTR_PARAM_BIND_OFFSET_PTR, 
                           &m_nParamBindOffset,
                           SQL_IS_POINTER );

    if ( !RC_SUCCESS( rc ) )
        return rc;


    // execute the statement sequentially
    for ( UINT nRow = 0; nRow < vRow.size(); ++nRow ) {

        BUF *pRow = &vRow[nRow];

        pRow->num    = nRow;
        pRow->numIND = sizeof( pRow->num );

        m_nParamBindOffset = ( SQLUINTEGER ) 
            ( (intptr_t ) pRow - (intptr_t ) pBaseRow );

        rc = SQLExecDirect( hstmt,
                            (SQLCHAR *) szSQL,
                            ( SQLINTEGER ) strlen( szSQL ) );

        ASSERT( RC_SUCCESS( rc ) );

        if ( !RC_SUCCESS( rc ) )
            break;
    }


    ::SQLFreeStmt( hstmt, SQL_DROP );
    hstmt = NULL;

    // disconnect done by caller

    return rc;
}


SQLRETURN CChildView::TestBindParamOffsetPtrInsert2( SQLHENV  &henv,
                                                     SQLHDBC  &hdbc,
                                                     SQLHSTMT &hstmt,
                                                     const bool bBindOffset ) {

    ASSERT( henv != NULL );
    ASSERT( hdbc != NULL );
    ASSERT( hstmt == NULL );


    const UINT ROW_COUNT = 500;
    vector< BUF2 >   vRow( ROW_COUNT );   // our row buffer

    // get a the first row of the buffer so we can use it to bind the parameter
    BUF2 *pBaseRow = &vRow[0];
    
    // parameter bind offset
    SQLUINTEGER     m_nParamBindOffset = 0;

    // table ddl
/*
CREATE TABLE test_bind_param (
 drg CHAR(3) NOT NULL,
 description VARCHAR(50),
 drg_weight DECIMAL(6,2),
 runid INTEGER
);
CREATE TABLE test_no_bind_param (
 drg CHAR(3) NOT NULL,
 description VARCHAR(50),
 drg_weight DECIMAL(6,2),
 runid INTEGER
);
*/


    const char *szSQL = bBindOffset ?
"insert into test_bind_param    ( drg, description, drg_weight ) values ( ?, ?, ? )" :
"insert into test_no_bind_param ( drg, description, drg_weight ) values ( ?, ?, ? )";

    SQLRETURN rc = SQLAllocStmt( hdbc, &hstmt );

    if ( !RC_SUCCESS( rc ) )
        return rc;

    // bind the parameter
    rc = ::SQLBindParameter( hstmt, 
                             1,    // one-based
				             SQL_PARAM_INPUT, 
                             SQL_C_CHAR,   // nValueType,
				             SQL_CHAR,   // ParameterType, 
                             3, // cbColumnSize
				             0,             // DecimalDigits 
                             pBaseRow->drg,   // pBuffer, 
                             4, // nBufferLength,
				             &pBaseRow->drgIND ); // StrLen_or_IndPtr

    if ( !RC_SUCCESS( rc ) )
        return rc;

    // bind the parameter
    rc = ::SQLBindParameter( hstmt, 
                             2,    // one-based
				             SQL_PARAM_INPUT, 
                             SQL_C_CHAR,   // nValueType,
				             SQL_VARCHAR,   // ParameterType, 
                             50, // cbColumnSize
				             0,             // DecimalDigits 
                             pBaseRow->description,   // pBuffer, 
                             71, // nBufferLength,
				             &pBaseRow->descriptionIND ); // StrLen_or_IndPtr

    if ( !RC_SUCCESS( rc ) )
        return rc;


    // bind the parameter
    rc = ::SQLBindParameter( hstmt, 
                             3,    // one-based
				             SQL_PARAM_INPUT, 
                             SQL_C_CHAR,   // nValueType,
				             SQL_DECIMAL,   // ParameterType, 
                             6, // cbColumnSize
				             2,             // DecimalDigits 
                             pBaseRow->drg_weight,   // pBuffer, 
                             13, // nBufferLength,
				             &pBaseRow->drg_weightIND ); // StrLen_or_IndPtr

    if ( !RC_SUCCESS( rc ) )
        return rc;

    if ( bBindOffset ) {

        // enable param binding offsets use
        rc = ::SQLSetStmtAttr( hstmt, 
                            SQL_ATTR_PARAM_BIND_OFFSET_PTR, 
                            &m_nParamBindOffset,
                            SQL_IS_POINTER );

        if ( !RC_SUCCESS( rc ) )
            return rc;
    }

    for ( UINT nRow = 0; nRow < vRow.size(); ++nRow ) {

        BUF2 *pRow = bBindOffset ? &vRow[nRow] : &vRow[0];

        _ltoa( nRow, pRow->drg, 10 );
        pRow->drgIND = (long) strlen( pRow->drg );

        _ltoa( nRow + 1000, pRow->description, 10 );
        pRow->descriptionIND = (long) strlen( pRow->description );

        CString sDrgWeight;

        sDrgWeight.Format("%d.25", nRow );

        strcpy( pRow->drg_weight, sDrgWeight );
        pRow->drg_weightIND = (long) strlen( pRow->drg_weight );

        if ( bBindOffset ) {

            m_nParamBindOffset = ( SQLUINTEGER ) 
                ( (intptr_t ) pRow - (intptr_t ) pBaseRow );
        }

        rc = SQLExecDirect( hstmt,
                            (SQLCHAR *) szSQL,
                            ( SQLINTEGER ) strlen( szSQL ) );

        ASSERT( RC_SUCCESS( rc ) );

        if ( !RC_SUCCESS( rc ) )
            break;
    }

    // disconnect done by caller

    return rc;
}

SQLRETURN CChildView::TestBindParamOffsetPtrInsert3( SQLHENV  &henv,
                                                     SQLHDBC  &hdbc,
                                                     SQLHSTMT &hstmt,
                                                     const bool bBindOffset ) {

    ASSERT( henv != NULL );
    ASSERT( hdbc != NULL );
    ASSERT( hstmt == NULL );
    //ASSERT( bBindOffset );

    SQLRETURN rc = SQL_SUCCESS;

    // base row for binding
    //BUF3 row;
    //BUF3 *pBaseRow = &vRow[0];
    BUF3 *pRowBind = ( BUF3 * ) malloc( sizeof( BUF3 ) );
    //BUF3 *pRowBind = 0;

    ASSERT( pRowBind != NULL );

    const UINT ROW_COUNT = 100;
    const UINT ROW_ALLOC = 10000;
    //vector< BUF3 >   vRow( ROW_COUNT );   // our row buffer
    char *pArray = ( char * ) GlobalAllocPtr( GHND,
                                              sizeof( BUF3 ) * ROW_ALLOC );

    ASSERT( pArray != NULL );

    // table ddl
/*
CREATE TABLE test_param_data (
 mpcno CHAR(2) NOT NULL,
 mpcdesc VARCHAR(100)
);
*/

    const UINT ROW_START = 9000;

    ASSERT( ROW_START < ROW_ALLOC );
    ASSERT( ROW_START + ROW_COUNT < ROW_ALLOC );

    const char *szSQL = bBindOffset ?
"insert into test_param_data ( mpcno, mpcdesc ) values ( ?, ? )" :
"insert into test_param_data ( mpcno, mpcdesc ) values ( ?, ? )";

    rc = SQLAllocStmt( hdbc, &hstmt );

    if ( !RC_SUCCESS( rc ) )
        goto ExitTest3;

    // parameter bind offset
    SQLUINTEGER     m_nParamBindOffset = 0;

    if ( bBindOffset ) {

        // enable param binding offsets use
        rc = ::SQLSetStmtAttr( hstmt, 
                            SQL_ATTR_PARAM_BIND_OFFSET_PTR, 
                            &m_nParamBindOffset,
                            SQL_IS_POINTER );

        if ( !RC_SUCCESS( rc ) )
            goto ExitTest3;
    }

    // bind the parameter
    rc = ::SQLBindParameter( hstmt, 
                             1,    // one-based
				             SQL_PARAM_INPUT, 
                             SQL_C_CHAR,   // nValueType,
				             SQL_CHAR,   // ParameterType, 
                             2, // cbColumnSize
				             0,             // DecimalDigits 
                             pRowBind->mpcno,   // pBuffer, 
                             sizeof(pRowBind->mpcno), // nBufferLength,
				             &pRowBind->mpcnoIND ); // StrLen_or_IndPtr

    if ( !RC_SUCCESS( rc ) )
        goto ExitTest3;

    // bind the parameter
    rc = ::SQLBindParameter( hstmt, 
                             2,    // one-based
				             SQL_PARAM_INPUT, 
                             SQL_C_CHAR,   // nValueType,
				             SQL_VARCHAR,   // ParameterType, 
                             MPCDESC_SZ, // cbColumnSize
				             0,             // DecimalDigits 
                             pRowBind->mpcdesc,   // pBuffer, 
                             sizeof(pRowBind->mpcdesc), // nBufferLength,
				             &pRowBind->mpcdescIND ); // StrLen_or_IndPtr

    if ( !RC_SUCCESS( rc ) )
        goto ExitTest3;


    for ( UINT nRow = 1; nRow < ROW_COUNT; ++nRow ) {

        //BUF3 *pRow = bBindOffset ? &vRow[nRow] : &vRow[0];
        BUF3 *pRow = bBindOffset ? 
            ( ( BUF3 * ) ( pArray + ( ROW_START + nRow ) * sizeof( BUF3 ) ) ) : 
            pRowBind;


        CString sText;
        sText.Format( "%02d", nRow + 1 );

        strncpy( pRow->mpcno, sText, MPCNO_SZ );
        pRow->mpcno[ MPCNO_SZ ] = '\0';
        pRow->mpcnoIND = (long) strlen( pRow->mpcno );

        ASSERT( pRow->mpcnoIND <= MPCNO_SZ );

        const char *MPCDESC = ( nRow + 1 ) % 2 ? 
                            "INFECTIOUS DISEASES" : "ENDOCRINOLOGY";

        strcpy( pRow->mpcdesc, MPCDESC );
        pRow->mpcdescIND = (long) strlen( pRow->mpcdesc );

        ASSERT( pRow->mpcdescIND <= MPCDESC_SZ );


        if ( bBindOffset ) {

            m_nParamBindOffset = ( SQLUINTEGER ) 
                ( (intptr_t ) pRow - (intptr_t ) pRowBind );
        }

        rc = SQLExecDirect( hstmt,
                            (SQLCHAR *) szSQL,
                            ( SQLINTEGER ) strlen( szSQL ) );

        ASSERT( RC_SUCCESS( rc ) );

        if ( !RC_SUCCESS( rc ) )
            break;
    }

    // disconnect done by caller

ExitTest3:

    if ( pRowBind != NULL )
        free( pRowBind );

    if ( pArray != NULL )
        GlobalFreePtr( pArray );

    return rc;
}


SQLRETURN CChildView::TestUpdateTimeStamp( SQLHENV  &henv,
                                           SQLHDBC  &hdbc,
                                           SQLHSTMT &hstmt,
										   const bool bBindOffset ) {

    ASSERT( henv != NULL );
    ASSERT( hdbc != NULL );
    ASSERT( hstmt == NULL );

	const DWORD ROW_MAX = 10000;
    vector<ROUTE>   vRow(ROW_MAX);   // our row buffer

    // get a the first row of the buffer so we can use it to bind the parameter
    ROUTE *pBaseRow = &vRow[9000];

    
    // parameter bind offset
    SQLUINTEGER     m_nParamBindOffset = 0;

    const char *szSQL = 
"update route set rt_arrive_at = ? where rt_id = ?";

    SQLRETURN rc = SQLAllocStmt( hdbc, &hstmt );

    if ( !RC_SUCCESS( rc ) )
        return rc;

    // rt_arrive_at
    rc = ::SQLBindParameter( hstmt, 
                             1,    // one-based
				             SQL_PARAM_INPUT,
                             SQL_C_TYPE_TIMESTAMP,   // nValueType 93
				             SQL_TYPE_TIMESTAMP,   // ParameterType 93
                             19, // cbColumnSize
				             0,             // DecimalDigits 
                             &pBaseRow->rt_arrive_at,   // pBuffer, 
                             16, // nBufferLength,
				             &pBaseRow->rt_arrive_atIND ); // StrLen_or_IndPtr

    if ( !RC_SUCCESS( rc ) )
        return rc;

    // rt_id
    rc = ::SQLBindParameter( hstmt, 
                             2,    // one-based
				             SQL_PARAM_INPUT, 
                             SQL_C_SLONG,   // nValueType,
				             SQL_INTEGER,   // ParameterType, 
                             4, // cbColumnSize
				             24,             // DecimalDigits 
                             &pBaseRow->rt_id,   // pBuffer, 
                             sizeof(pBaseRow->rt_id), // nBufferLength,
				             &pBaseRow->rt_idIND ); // StrLen_or_IndPtr

    if ( !RC_SUCCESS( rc ) )
        return rc;

    if ( bBindOffset ) {

        // enable param binding offsets use
        rc = ::SQLSetStmtAttr( hstmt, 
                            SQL_ATTR_PARAM_BIND_OFFSET_PTR, 
                            &m_nParamBindOffset,
                            SQL_IS_POINTER );

        if ( !RC_SUCCESS( rc ) )
            return rc;
    }

	const DWORD nRow = 100;
    ROUTE *pRow = bBindOffset ? &vRow[nRow] : &vRow[0];

    pRow->rt_idIND = 4;
    pRow->rt_id	   = 4670;

	// 2006-10-11 12:33:00.000
	pRow->rt_arrive_atIND = sizeof( pRow->rt_arrive_at );
	pRow->rt_arrive_at.year		= 2006;
	pRow->rt_arrive_at.month	=   10;
	pRow->rt_arrive_at.day		=   11;
	pRow->rt_arrive_at.hour		=   12;
	pRow->rt_arrive_at.minute	=   33;
	pRow->rt_arrive_at.second	=    0;
	pRow->rt_arrive_at.fraction = 0;

	pRow->junk[0] = 0xff;
	pRow->junk[1] = 0xee;

    if ( bBindOffset ) {

        m_nParamBindOffset = ( SQLUINTEGER ) 
            ( (intptr_t ) pRow - (intptr_t ) pBaseRow );
    }

    rc = SQLExecDirect( hstmt,
                        (SQLCHAR *) szSQL,
                        ( SQLINTEGER ) strlen( szSQL ) );

	if ( RC_SUCCESS( rc ) ) {

		rc = SQLEndTran( SQL_HANDLE_DBC, hdbc, SQL_COMMIT );
	}

    //ASSERT( RC_SUCCESS( rc ) );

    // disconnect done by caller

    return rc;
}


void CChildView::TestUpdateTimeStamp( const bool bBindOffset ) {

    SQLHENV     henv = NULL;    
    SQLHDBC     hdbc = NULL;
    SQLHSTMT    hstmt = NULL;

    // to do: substitute your database connection info below
	//const char *szConnect = "DSN=demodb;UID=SYSTEM;PWD=SYSTEM";
    const char *szConnect = "DSN=demodb";

    ASSERT( szConnect != NULL && *szConnect );

    SQLRETURN rc = Connect( henv, hdbc, szConnect );

	if ( RC_SUCCESS( rc ) ) {

		rc = SetAutoCommit( hdbc, false );
	}

    if ( RC_SUCCESS( rc ) ) {

        // connected
		rc = TestUpdateTimeStamp( henv, hdbc, hstmt, bBindOffset );
    }

    if ( !RC_SUCCESS( rc ) ) {

        DiagSQLError( henv, hdbc, hstmt, rc, "", "" );
    }

    if ( hdbc != NULL )
        Disconnect( henv, hdbc );

    if ( henv != NULL )
        SQLFreeHandle( SQL_HANDLE_ENV, henv );
}

SQLRETURN CChildView::TestSQLTables( SQLHENV  &henv,
                                     SQLHDBC  &hdbc,
                                     const char *szTableCat,
                                     const char *szTableSchem,
					                 const char *szTableName,
                                     const char *szTableType,
                                     DWORD &cRow,
                                     const bool bRowBindOffset ) {

    ASSERT( henv != NULL );
    ASSERT( hdbc != NULL );
    //ASSERT( hstmt != NULL );

    SQLHSTMT hstmt = NULL;

    const bool bUI = false;

    if ( bUI ) {

        m_lb.ResetContent();
    }

	cRow = 0;

    // get a the first row of the buffer so we can use it to bind the parameter
    BUF rowbase;
    //BUF *pRowBind = &m_baseRow;
    BUF *pRowBind = &rowbase;
    vector< BUF >   vRow;

    // row bind offset
    SQLUINTEGER     nRowBindOffset = 0;

    SQLRETURN rc = ::SQLAllocHandle( SQL_HANDLE_STMT, hdbc, &hstmt );

    if ( !RC_SUCCESS( rc ) )
        return rc;


    //SQLHSTMT hstmt1 = NULL;
    //rc = SQLAllocStmt( hdbc, &hstmt1 );

    //if ( !RC_SUCCESS( rc ) )
    //    return rc;

//    const char *szSQL =
//"select 1 from sys.users where name = user \
//union all \
//select 2 from sys.users where name = user order by 1";
//
//    rc = SQLExecDirect( hstmt1, ( SQLCHAR * ) szSQL, strlen( szSQL ) );
//
//    if ( !RC_SUCCESS( rc ) )
//        DiagSQLError( henv, hdbc, hstmt1, rc, "order by 1" );
//
//    if ( hstmt1 != NULL ) {
//
//        ::SQLFreeStmt( hstmt1, SQL_DROP );
//        hstmt1 = NULL;
//    }


    // bind the resultset
    rc = ::SQLBindCol( hstmt, 
                    1,   // table cat
                    SQL_C_CHAR,   // TargetType,
				    pRowBind->table_cat,   // TargetValue, 
                    sizeof( pRowBind->table_cat), // BufferLength
				    &pRowBind->table_catIND ); // StrLen_or_IndPtr

    if ( !RC_SUCCESS( rc ) )
        return rc;

    rc = ::SQLBindCol( hstmt, 
                    2,   // table schem
                    SQL_C_CHAR,   // TargetType,
				    pRowBind->table_schem,   // TargetValue, 
                    sizeof( pRowBind->table_schem), // BufferLength
				    &pRowBind->table_schemIND ); // StrLen_or_IndPtr

    if ( !RC_SUCCESS( rc ) )
        return rc;

    rc = ::SQLBindCol( hstmt, 
                    3,   // table name
                    SQL_C_CHAR,   // TargetType,
				    pRowBind->table_name,   // TargetValue, 
                    sizeof( pRowBind->table_name), // BufferLength
				    &pRowBind->table_nameIND ); // StrLen_or_IndPtr

    if ( !RC_SUCCESS( rc ) )
        return rc;

    rc = ::SQLBindCol( hstmt, 
                    4,   // table type
                    SQL_C_CHAR,   // TargetType,
				    pRowBind->table_type,   // TargetValue, 
                    sizeof( pRowBind->table_type), // BufferLength
				    &pRowBind->table_typeIND ); // StrLen_or_IndPtr

    if ( !RC_SUCCESS( rc ) )
        return rc;



    // enable row binding offsets use
    if ( bRowBindOffset ) {

        rc = ::SQLSetStmtAttr( hstmt, 
                            SQL_ATTR_ROW_BIND_OFFSET_PTR, 
                            &nRowBindOffset,
                            SQL_IS_POINTER );

        if ( !RC_SUCCESS( rc ) )
            return rc;
    }


    size_t  cbTableCat   = szTableCat   == NULL ? 0 : strlen( szTableCat );
    size_t  cbTableSchem = szTableSchem == NULL ? 0 : strlen( szTableSchem );
    size_t  cbTableName  = szTableName  == NULL ? 0 : strlen( szTableName );
    size_t  cbTableType  = szTableType  == NULL ? 0 : strlen( szTableType );

    rc = ::SQLTables( hstmt,
                     ( SQLCHAR * )   szTableCat,
                     ( SQLSMALLINT ) cbTableCat,
                     ( SQLCHAR * )   szTableSchem,
                     ( SQLSMALLINT ) cbTableSchem,
                     ( SQLCHAR * )   szTableName,
                     ( SQLSMALLINT ) cbTableName,
                     ( SQLCHAR * )   szTableType,
                     ( SQLSMALLINT ) cbTableType );

    if ( !RC_SUCCESS ( rc ) )
        return rc;


    //SQLUSMALLINT nCol = 3;      // table_name
    //SQLINTEGER nBufferLength = 0;

    //// describe buffer length
    //rc = SQLColAttribute( hstmt,
    //                      nCol,
    //                      SQL_DESC_OCTET_LENGTH,
    //                      NULL,
    //                      0,
    //                      NULL,
    //                      &nBufferLength );

    //if ( !RC_SUCCESS( rc ) ) {

    //    DiagSQLError( henv, hdbc, hstmt, rc, "SQLColAttribute SQL_DESC_OCTET_LENGTH" );
    //}

    //CString sText;

    //sText.Format( "   ---  Table Name buffer size: %d  ---", nBufferLength );
    //    
    //m_lb.AddString( sText );



    //// num prec radix
    //SQLPOINTER nNumPrecRadix = 0;

    //rc = SQLColAttribute( hstmt,
    //                      nCol,
    //                      SQL_DESC_NUM_PREC_RADIX,
    //                      NULL,
    //                      0,
    //                      NULL,
    //                      &nNumPrecRadix );

    //if ( !RC_SUCCESS( rc ) ) {

    //    DiagSQLError( henv, hdbc, hstmt, rc, 
    //        "SQLColAttribute SQL_DESC_NUM_PREC_RADIX" );
    //}

    rc = FetchRows( hstmt, cRow, pRowBind, nRowBindOffset, vRow, 
                                                            bRowBindOffset );

    if ( bUI ) {

        for ( UINT nRow = 0; nRow < vRow.size(); ++nRow ) {

            const BUF &row = vRow[nRow];

            if ( szTableType == SQL_ALL_TABLE_TYPES ) {

                m_lb.AddString( row.table_type );
            }
            else {

                CString sText;

                if ( row.table_catIND != SQL_NULL_DATA )
                    sText = row.table_cat;
                sText += " - ";

                if ( row.table_schemIND != SQL_NULL_DATA )
                    sText += row.table_schem;
                sText += " - ";

                if ( row.table_nameIND != SQL_NULL_DATA )
                    sText += row.table_name;
                sText += " - ";

                if ( row.table_typeIND != SQL_NULL_DATA )
                    sText += row.table_type;

                m_lb.AddString( sText );
            }
        }
    }

    if ( hstmt != NULL ) {

        ::SQLFreeStmt( hstmt, SQL_DROP );
        hstmt = NULL;
    }

    return SQL_SUCCESS;
}


template< typename T >
    SQLRETURN CChildView::FetchRows( SQLHSTMT &hstmt,
                                 DWORD &cFetched,
                                 T *pRowBind,
                                 SQLUINTEGER &nRowBindOffset,
                                 vector< T > &vRow,
                                 const bool bRowBindOffset ) {
    SQLRETURN   rc;

    cFetched = 0;   // number of rows fetched in this call

    vRow.clear();

    while ( 1 ) {

        T buf;

        vRow.push_back( buf );

        T *pRow = &vRow.back();

        // uses bind offsets
        nRowBindOffset = ( SQLUINTEGER ) 
                           ( (intptr_t ) pRow - (intptr_t ) pRowBind );

		rc = FetchNextRow( hstmt );

        if ( rc == SQL_NO_DATA_FOUND )
            break;

        if ( !RC_SUCCESS ( rc ) ) {

            // done with resultset close it
            ::SQLFreeStmt( hstmt, SQL_CLOSE );
            hstmt = NULL;
            break;
        }

        if ( !bRowBindOffset )
            memcpy( pRow, pRowBind, sizeof( T ) );

        ++cFetched;
    }

    // remove the last row
    ASSERT( vRow.size() > 0 );

    vRow.erase( vRow.begin() + vRow.size() - 1 );

    return rc == SQL_NO_DATA_FOUND && vRow.size() > 0 ? SQL_SUCCESS : rc;
}


SQLRETURN CChildView::SetAutoCommit( SQLHDBC hdbc, const bool bAutoCommit ) {

    RETCODE rc = SQLSetConnectAttr( hdbc, SQL_AUTOCOMMIT,
        bAutoCommit ? (SQLPOINTER ) SQL_AUTOCOMMIT_ON : SQL_AUTOCOMMIT_OFF, 
                    SQL_IS_UINTEGER );

	if ( bAutoCommit ) {

		rc = SQLEndTran( SQL_HANDLE_DBC, hdbc, SQL_COMMIT );
	}

    return rc;
}


SQLRETURN CChildView::FetchNextRow( HSTMT &hstmt ) {

    SQLRETURN rc = ::SQLFetch( hstmt );

    if ( RC_SUCCESS (rc) ) {

        if ( rc == SQL_SUCCESS_WITH_INFO ) {
		    ASSERT( FALSE );
        }

	    return rc;
    }
    else if ( rc == SQL_NO_DATA_FOUND ) {

        // done with the statement, close it
        rc = ::SQLFreeStmt( hstmt, SQL_CLOSE );
        hstmt = NULL;

	    if ( !RC_SUCCESS( rc ) ) {
            
            ASSERT( FALSE );
	    }

        return SQL_NO_DATA_FOUND;
    }

    return rc;
}


int CChildView::OnCreate(LPCREATESTRUCT lpCreateStruct) {

    if (CWnd::OnCreate(lpCreateStruct) == -1)
        return -1;

    m_lb.Create( WS_CHILD | WS_VISIBLE | WS_VSCROLL | WS_HSCROLL |
                 WS_TABSTOP |WS_BORDER, CRect( 10, 10, 500, 500 ), this, 0 );

    return 0;
}

void CChildView::Testparameterbindoffsetinsert( const bool bBindOffset,
                                                const UINT nTest ) {

    ASSERT( nTest >= 2 && nTest <= 3 );

    SQLHENV     henv = NULL;    
    SQLHDBC     hdbc = NULL;
    SQLHSTMT    hstmt = NULL;

    // to do: substitute your database connection info below
    const char *szConnect = "DSN=ants;UID=SYSTEM;PWD=SYSTEM";

    ASSERT( szConnect != NULL && *szConnect );

    SQLRETURN rc = Connect( henv, hdbc, szConnect );

    if ( RC_SUCCESS( rc ) ) {

        // connected

        if ( nTest == 2 )
            rc = TestBindParamOffsetPtrInsert2( henv, hdbc, hstmt, bBindOffset );
        else if ( nTest == 3 )
            rc = TestBindParamOffsetPtrInsert3( henv, hdbc, hstmt, bBindOffset );
        else {
            ASSERT( FALSE );
        }
    }

    if ( !RC_SUCCESS( rc ) ) {

        DiagSQLError( henv, hdbc, hstmt, rc, "", "" );
    }

    if ( hdbc != NULL )
        Disconnect( henv, hdbc );

    if ( henv != NULL )
        SQLFreeHandle( SQL_HANDLE_ENV, henv );
}


void CChildView::OnTestTestparameterbindoffsetinsert() {

    Testparameterbindoffsetinsert( true, 2 );
}

void CChildView::OnUpdateTestTestparameterbindoffsetinsert(CCmdUI *pCmdUI) {

    pCmdUI->Enable( TRUE );
}

void CChildView::OnTestTestwithoutparameterbindoffset() {
    Testparameterbindoffsetinsert( false, 2 );
}

void CChildView::OnUpdateTestTestwithoutparameterbindoffset(CCmdUI *pCmdUI) {

    pCmdUI->Enable( TRUE );
}

void CChildView::OnTestTestparameterlongerror(){

    Testparameterbindoffsetinsert( true, 3 );
}

void CChildView::OnUpdateTestTestparameterlongerror(CCmdUI *pCmdUI) {

    pCmdUI->Enable( TRUE );
}

void CChildView::OnTestTestparameterlongerrornobindoffsetpointer() {

    Testparameterbindoffsetinsert( false, 3 );
}

void CChildView::OnUpdateTestTestparameterlongerrornobindoffsetpointer(CCmdUI *pCmdUI) {

    pCmdUI->Enable( TRUE );
}


void CChildView::OnTestSQLTablesWithRowoffsetpointer() {
    TestSQLTables( true );
}
void CChildView::OnUpdateTestSQLTablesWithRowOffsetPointer(CCmdUI *pCmdUI) {
    pCmdUI->Enable( TRUE );
}

void CChildView::OnTestSQLTablesWithoutrowoffsetpointer() {
    TestSQLTables( false );
}
void CChildView::OnUpdateTestSQLTtablesWithoutrowoffsetpointer(CCmdUI *pCmdUI) {
    pCmdUI->Enable( TRUE );
}

///////////////////////////////////////////////////////////////////////////////
//
//	Class:		CChildView
//
//	Method:		CreateThreadSuspend
//
//	Scope:		protected
//
//	Arguments:	pThread
//              bAutoDelete
//              nPriority
//              nStackSize
//              dwCreateFlags
//              lpSecurityAttrs
//
//	Returns:	BOOL
//
//	Description:
//	Create a suspended thread for the given parameters
//
///////////////////////////////////////////////////////////////////////////////
BOOL CChildView::CreateThreadSuspend( CWinThread *pThread,
                                       const bool bAutoDelete,
                                       int nPriority,
                                       UINT nStackSize,
                                       DWORD dwCreateFlags,
                                       LPSECURITY_ATTRIBUTES lpSecurityAttrs ) {

	ASSERT_VALID(pThread);

	if ( !pThread->CreateThread( dwCreateFlags | CREATE_SUSPENDED, 
                                 nStackSize,
		                         lpSecurityAttrs ) ) {
		return FALSE;
	}

	VERIFY(pThread->SetThreadPriority(nPriority));

    // whether to delete the created CWinThread object on termination
    pThread->m_bAutoDelete = bAutoDelete;

	//if ( !( dwCreateFlags & CREATE_SUSPENDED ) )
	//	VERIFY(pThread->ResumeThread() != (DWORD)-1);

	return TRUE;
}

UINT CChildView::TestSQLTablesMTProc( LPVOID param ) {

    TEST_MT *pParam = reinterpret_cast< TEST_MT * >
                                    ( param );


    DWORD cRow = 0;

    pParam->pView->TestSQLTables( pParam->henv, 
                                  pParam->hdbc, 
                                  "", // catalog
                                  "", // schema
                                  "", // table name
                                  "", // table types,
                                  cRow,
                                  true /*bParamBindOffset*/ );

    return 0;
}

UINT CChildView::TestSQLAllocStmtMTProc( LPVOID param ) {

    TEST_MT *pParam = reinterpret_cast< TEST_MT * >
                                    ( param );


    DWORD cRow = 0;

    pParam->pView->TestSQLAllocStmt( pParam->henv, 
									 pParam->hdbc );

    return 0;
}


void CChildView::OnTestTestsqltablemulti() {

    TestSQLTablesMT();
}

void CChildView::OnUpdateTestTestsqltablemulti(CCmdUI *pCmdUI) {

    pCmdUI->Enable( TRUE );
}


void CChildView::TestGarbledCharData( const bool bParamBindOffset ) {

    SQLHENV     henv = NULL;    
    SQLHDBC     hdbc = NULL;
    SQLHSTMT    hstmt = NULL;

    // to do: substitute your database connection info below
    //ASSERT( FALSE );
    const char *szConnect = "DSN=PostgreSQL30W;UID=;PWD=";


    ASSERT( szConnect != NULL && *szConnect );

    SQLRETURN rc = Connect( henv, hdbc, szConnect );

    if ( rc == SQL_SUCCESS_WITH_INFO )
        DiagSQLError( henv, hdbc, hstmt, rc, "", "" );

    rc = SetAutoCommit( hdbc, false );

    if ( !RC_SUCCESS( rc ) )
        DiagSQLError( henv, hdbc, hstmt, rc, "", "" );



    if ( RC_SUCCESS( rc ) ) {

        // connected

        DWORD cRow = 0;
        rc = TestGarbledCharData( henv, hdbc, cRow, bParamBindOffset );
    }

    if ( !RC_SUCCESS( rc ) ) {

        DiagSQLError( henv, hdbc, hstmt, rc, "", "" );
    }

    if ( hdbc != NULL )
        Disconnect( henv, hdbc );

    if ( henv != NULL )
        SQLFreeHandle( SQL_HANDLE_ENV, henv );
}


SQLRETURN CChildView::TestGarbledCharData( SQLHENV  &henv,
                                           SQLHDBC  &hdbc,
                                           DWORD &cRow,
                                           const bool bRowBindOffset ) {

    ASSERT( henv != NULL );
    ASSERT( hdbc != NULL );
    //ASSERT( hstmt != NULL );

    SQLHSTMT hstmt = NULL;

    const bool bUI = true;

    if ( bUI ) {

        m_lb.ResetContent();
    }

	cRow = 0;

    // get a the first row of the buffer so we can use it to bind the parameter
    BUF4 rowbase;
    //BUF4 *pRowBind = &m_baseRow;
    BUF4 *pRowBind = &rowbase;
    vector< BUF4 >   vRow;

    // row bind offset
    SQLUINTEGER     nRowBindOffset = 0;

    SQLRETURN rc = SQLAllocStmt( hdbc, &hstmt );

    if ( !RC_SUCCESS( rc ) )
        return rc;


    // bind the resultset
    rc = ::SQLBindCol( hstmt, 
                    1,   // cmp_type_cd
                    SQL_C_CHAR,   // TargetType,
				    pRowBind->cmp_type_cd,   // TargetValue, 
                    sizeof( pRowBind->cmp_type_cd), // BufferLength
				    &pRowBind->cmp_type_cdIND ); // StrLen_or_IndPtr

    if ( !RC_SUCCESS( rc ) )
        return rc;

    rc = ::SQLBindCol( hstmt, 
                    2,   // description
                    SQL_C_CHAR,   // TargetType,
				    pRowBind->description,   // TargetValue, 
                    sizeof( pRowBind->description), // BufferLength
				    &pRowBind->descriptionIND ); // StrLen_or_IndPtr

    if ( !RC_SUCCESS( rc ) )
        return rc;

    rc = ::SQLBindCol( hstmt, 
                    3,   // ctrl_ins_dtm
                    SQL_C_TYPE_TIMESTAMP,   // TargetType,
				    &pRowBind->ctrl_ins_dtm,   // TargetValue, 
                    sizeof( pRowBind->ctrl_ins_dtm), // BufferLength
				    &pRowBind->ctrl_ins_dtmIND ); // StrLen_or_IndPtr

    if ( !RC_SUCCESS( rc ) )
        return rc;

    rc = ::SQLBindCol( hstmt, 
                    4,   // ctrl_upd_dtm
                    SQL_C_TYPE_TIMESTAMP,   // TargetType,
				    &pRowBind->ctrl_upd_dtm,   // TargetValue, 
                    sizeof( pRowBind->ctrl_upd_dtm), // BufferLength
				    &pRowBind->ctrl_upd_dtmIND ); // StrLen_or_IndPtr

    if ( !RC_SUCCESS( rc ) )
        return rc;

    rc = ::SQLBindCol( hstmt, 
                    5,   // ctrl_usr_id
                    SQL_C_CHAR,   // TargetType,
				    pRowBind->ctrl_usr_id,   // TargetValue, 
                    sizeof( pRowBind->ctrl_usr_id), // BufferLength
				    &pRowBind->ctrl_usr_idIND ); // StrLen_or_IndPtr

    if ( !RC_SUCCESS( rc ) )
        return rc;

    // enable row binding offsets use
    if ( bRowBindOffset ) {

        rc = ::SQLSetStmtAttr( hstmt, 
                            SQL_ATTR_ROW_BIND_OFFSET_PTR, 
                            &nRowBindOffset,
                            SQL_IS_POINTER );

        if ( !RC_SUCCESS( rc ) )
            return rc;
    }

/*
create table in_sync_cmp_type (
cmp_type_cd          CHAR(8)              not null,
description          VARCHAR(30)          not null,
ctrl_ins_dtm         TIMESTAMP            not null default CURRENT_TIMESTAMP,
ctrl_upd_dtm         TIMESTAMP            not null,
ctrl_usr_id          VARCHAR(128)         not null,
constraint PK_IN_SYNC_CMP_TYPE primary key (cmp_type_cd)
);

-- sample data
INSERT INTO in_sync_cmp_type VALUES (
	'DATA',
	'Data',
	'2005-11-18 00:00:00',
	'2005-11-18 00:00:00',
	'sys');

INSERT INTO in_sync_cmp_type VALUES (
	'COL',
	'Column',
	'2005-12-21 00:00:00',
	'2005-12-21 00:00:00',
	'sys');
INSERT INTO in_sync_cmp_type VALUES (
	'COLM',
	'Column',
	'2005-12-21 00:00:00',
	'2005-12-21 00:00:00',
	'sys');

INSERT INTO in_sync_cmp_type VALUES (
	'IDX',
	'Index',
	'2005-12-21 00:00:00',
	'2005-12-21 00:00:00',
	'sys');
INSERT INTO in_sync_cmp_type VALUES (
	'IDXM',
	'Index',
	'2005-12-21 00:00:00',
	'2005-12-21 00:00:00',
	'sys');
	
INSERT INTO in_sync_cmp_type VALUES (
	'PK',
	'PK',
	'2005-12-15 00:00:00',
	'2005-12-15 00:00:00',
	'sys');
INSERT INTO in_sync_cmp_type VALUES (
	'PKM',
	'PK',
	'2005-12-15 00:00:00',
	'2005-12-15 00:00:00',
	'sys');
		
INSERT INTO in_sync_cmp_type VALUES (
	'FK',
	'FK',
	'2005-11-18 00:00:00',
	'2005-11-18 00:00:00',
	'sys');
INSERT INTO in_sync_cmp_type VALUES (
	'FKM',
	'FK',
	'2005-11-18 00:00:00',
	'2005-11-18 00:00:00',
	'sys');

	
INSERT INTO in_sync_cmp_type VALUES (
	'PRIV',
	'Privilege',
	'2005-12-21 00:00:00',
	'2005-12-21 00:00:00',
	'sys');
INSERT INTO in_sync_cmp_type VALUES (
	'PRIVM',
	'Privilege',
	'2005-12-21 00:00:00',
	'2005-12-21 00:00:00',
	'sys');

INSERT INTO in_sync_cmp_type VALUES (
	'TABLE',
	'Tables',
	'2005-12-21 00:00:00',
	'2005-12-21 00:00:00',
	'sys');
	
INSERT INTO in_sync_cmp_type VALUES (
	'FOLDER',
	'Folder',
	'2006-01-26 00:00:00',
	'2006-01-26 00:00:00',
	'sys');

INSERT INTO in_sync_cmp_type VALUES (
	'TRG',
	'Trigger',
	'2006-02-28 00:00:00',
	'2006-02-28 00:00:00',
	'sys');
INSERT INTO in_sync_cmp_type VALUES (
	'TRGM',
	'Trigger',
	'2006-02-28 00:00:00',
	'2006-02-28 00:00:00',
	'sys');

INSERT INTO in_sync_cmp_type VALUES (
	'PROCLS',
	'Procedures',
	'2006-04-13 00:00:00',
	'2006-04-13 00:00:00',
	'sys');

INSERT INTO in_sync_cmp_type VALUES (
	'TEXT',
	'Text',
	'2006-05-08 00:00:00',
	'2006-05-08 00:00:00',
	'sys');

INSERT INTO in_sync_cmp_type VALUES (
	'PCOL',
	'Procedure/Function Column',
	'2006-06-06 00:00:00',
	'2006-06-06 00:00:00',
	'sys');
INSERT INTO in_sync_cmp_type VALUES (
	'PCOLM',
	'Procedure/Function Column',
	'2006-06-06 00:00:00',
	'2006-06-06 00:00:00',
	'sys');

*/
    const char *szSQL =
"select \
cmp_type_cd, \
description, \
ctrl_ins_dtm, \
ctrl_upd_dtm, \
ctrl_usr_id \
from in_sync_cmp_type";

    rc = SQLExecDirect( hstmt, 
                        ( SQLCHAR * ) szSQL, 
                        (SQLINTEGER) strlen( szSQL ) );

    if ( !RC_SUCCESS ( rc ) )
        return rc;

    rc = FetchRows( hstmt, cRow, pRowBind, nRowBindOffset, vRow, 
                                                            bRowBindOffset );
    if ( hstmt != NULL ) {

        ::SQLFreeStmt( hstmt, SQL_DROP );
        hstmt = NULL;
    }

    if ( bUI && RC_SUCCESS( rc ) ) {

        // write to list
        for ( UINT nRow = 0; nRow < vRow.size(); ++nRow ) {

            const BUF4 &row = vRow[nRow];

            CString sText;

            if ( row.cmp_type_cdIND != SQL_NULL_DATA )
                sText = row.cmp_type_cd;
            else
                sText = "<null>";

            sText += " - ";

            if ( row.descriptionIND != SQL_NULL_DATA )
                sText += row.description;
            else
                sText += "<null>";

            sText += " - ";

            m_lb.AddString( sText );
        }
    }

    return rc;
}

void CChildView::TestConnect() {

	SQLHENV     henvFB = NULL;    
	SQLHDBC     hdbcFB = NULL;
	SQLHSTMT    hstmtFB = NULL;

	// connect to Firebird
	// data source is not created on purpose to cause crash or you can create
	// a real firebird ODBC data source and you will also get a crash later trying
	// to connect to MySQL if you successfully connect to Firebird
	const char *szConnect = "DSN=fbtest;UID=SYSDBA;PWD=MASTERKEY";

	ASSERT( szConnect != NULL && *szConnect );

	SQLRETURN rc = Connect( henvFB, hdbcFB, szConnect );

	if ( !RC_SUCCESS( rc ) ) {

		DiagSQLError( henvFB, hdbcFB, hstmtFB, rc, "", "" );
	}


	const UINT cTryMax = 10;

	for ( UINT cTry = 0; cTry < cTryMax && hdbcFB != NULL; ++cTry ) {

		SQLHENV     henv = NULL;    
		SQLHDBC     hdbc = NULL;
		SQLHSTMT    hstmt = NULL;

		// to do: substitute your database connection info below
		ASSERT( FALSE );
		const char *szConnect = "DSN=mysql;UID=root;PWD=root";


		ASSERT( szConnect != NULL && *szConnect );

		SQLRETURN rc = Connect( henv, hdbc, szConnect );

		if ( !RC_SUCCESS( rc ) ) {

			DiagSQLError( henv, hdbc, hstmt, rc, "", "" );
		}
		else {

			// successfully connected to database

			rc = SetAutoCommit( hdbc, false );

			if ( !RC_SUCCESS( rc ) )
				DiagSQLError( henv, hdbc, hstmt, rc, "", "" );

			const bool bCommitOnDisconnect = false;

			rc = ::SQLTransact( henv, hdbc, 
					bCommitOnDisconnect ? SQL_COMMIT : SQL_ROLLBACK );

			if ( !RC_SUCCESS( rc ) )
				DiagSQLError( henv, hdbc, hstmt, rc, "", "" );
		}

		if ( hdbc != NULL )
			Disconnect( henv, hdbc );

		if ( henv != NULL )
			SQLFreeHandle( SQL_HANDLE_ENV, henv );

		if ( !RC_SUCCESS( rc ) )
			break;
	}

	if ( hdbcFB != NULL )
		Disconnect( henvFB, hdbcFB );

	if ( henvFB != NULL )
		SQLFreeHandle( SQL_HANDLE_ENV, henvFB );

}


void CChildView::OnTestRuntest() {

    TestConnect();
}

void CChildView::OnUpdateTestRuntest(CCmdUI *pCmdUI) {

    pCmdUI->Enable( TRUE );
}

void CChildView::OnTest2() {

    TestGarbledCharData( false );
}

void CChildView::OnUpdateTest2(CCmdUI *pCmdUI) {

    pCmdUI->Enable( FALSE );
}


void CChildView::GetLastError( const char *szCaption,  
					           const char *szRoutine ) {

    bool bProcessed = false;
    DWORD nLastError = ::GetLastError();

   // // check for extended internet errors
   // if ( nLastError == ERROR_INTERNET_EXTENDED_ERROR ) {

   //     // allocate on stack so it will be freed automatically
   //     const UINT BUF_SZ = 2048;
   //     DWORD dwLen = BUF_SZ;
   //     TCHAR *szBuf = ( TCHAR * ) _alloca( BUF_SZ );

   //     DWORD dwError;

   //     if ( InternetGetLastResponseInfo( &dwError, szBuf, &dwLen ) ) {

   //         bProcessed = true;
			//MessageBox( (LPCTSTR) szBuf, ROUTINE, MB_OK );
   //     }
   //     else {

   //         nLastError = ::GetLastError();
   //     }
   // }


    if ( !bProcessed ) {

        LPVOID lpMsgBuf;

        ::FormatMessage( FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM |
                         FORMAT_MESSAGE_IGNORE_INSERTS,
                         NULL, nLastError, 
                        MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), 
                        (LPTSTR) &lpMsgBuf,0,NULL);

		MessageBox( (LPCTSTR) lpMsgBuf, szRoutine, MB_OK );

        // Free the buffer.
        LocalFree( lpMsgBuf );
    }
}

SQLRETURN CChildView::TestSQLAllocStmt( SQLHENV  &henv,
                                        SQLHDBC  &hdbc ) {

    ASSERT( henv != NULL );
    ASSERT( hdbc != NULL );

	SQLHSTMT hstmt = NULL;

	SQLRETURN rc = ::SQLAllocHandle( SQL_HANDLE_STMT, hdbc, &hstmt );

	if ( !RC_SUCCESS( rc ) )
		return rc;

	rc = ExecuteSQLProcedureColumns( hstmt, "", "", "My Comparisons" );

	if ( hstmt != NULL ) {

		::SQLFreeStmt( hstmt, SQL_DROP );
		hstmt = NULL;
	}

	if ( !RC_SUCCESS( rc ) )
		return rc;


	for ( UINT i = 0; i < 10; ++i ) {

		SQLHSTMT hstmt = NULL;

		SQLRETURN rc = ::SQLAllocHandle( SQL_HANDLE_STMT, hdbc, &hstmt );

		if ( !RC_SUCCESS( rc ) )
			return rc;

		if ( hstmt != NULL ) {

			::SQLFreeStmt( hstmt, SQL_DROP );
			hstmt = NULL;
		}
	}

    return SQL_SUCCESS;
}

SQLRETURN CChildView::ExecuteSQLProcedureColumns( SQLHSTMT hstmt,
                                           const TCHAR *szProcedureCat,
                                           const TCHAR *szProcedureSchem,
                                           const TCHAR *szProcedureName ) {

	const char *ROUTINE = "ExecuteSQLProcedureColumns";

    ASSERT( hstmt != NULL );

    size_t  cbProcedureCat   = _tcslen( szProcedureCat );
    size_t  cbProcedureSchem = _tcslen( szProcedureSchem );
    size_t  cbProcedureName  = _tcslen( szProcedureName );

    // must use NULL for empty string input parameters
    ASSERT( *szProcedureName );

    SQLRETURN rc = ::SQLProcedureColumns( 
                            hstmt,
                            ( SQLCHAR * )   ( *szProcedureCat ? szProcedureCat : NULL ),
                            ( SQLSMALLINT ) cbProcedureCat,
                            ( SQLCHAR * )   ( *szProcedureSchem ? szProcedureSchem : NULL ),
                            ( SQLSMALLINT ) cbProcedureSchem,
                            ( SQLCHAR * )   szProcedureName,
                            ( SQLSMALLINT ) cbProcedureName,
                            NULL, 0 );

	return rc;
}
