// ChildView.h : interface of the CChildView class
//


#pragma once
#include <vector>


enum { TABLE_CAT_SZ   = 255 };
enum { TABLE_SCHEM_SZ = 128 };
enum { TABLE_NAME_SZ  = 128 };
enum { TABLE_TYPE_SZ  = 60 };

#pragma pack( push, 1 )
typedef struct tagBuf {

    long    numIND;
    long    num;

    long    descriptionIND;
    char    description[ 100 ];

    long    table_catIND;
	char	table_cat[ TABLE_CAT_SZ + 1 ]; 

    long    table_schemIND;
	char	table_schem[ TABLE_SCHEM_SZ + 1 ]; 

    long    table_nameIND;
    char    table_name[ TABLE_NAME_SZ + 1 ];

    long    table_typeIND;
    char    table_type[ TABLE_TYPE_SZ + 1 ];

    struct tagBuf() {

        numIND = SQL_NULL_DATA;
        num    = 0;

        const char *DESCRIPTION = "This is a description of some sort. Testing";

        descriptionIND = (long) strlen( DESCRIPTION );
        strcpy( description, DESCRIPTION );

        table_catIND = SQL_NULL_DATA;
        table_cat[0] = 0;

        table_schemIND = SQL_NULL_DATA;
        table_schem[0] = 0;

        table_nameIND  = SQL_NULL_DATA;
        table_name[0]  = 0;

        table_typeIND  = SQL_NULL_DATA;
        table_type[0]  = 0;
    }

} BUF;

#pragma pack( pop )


typedef struct tagBuf2 {

    long    drgIND;
    char    drg[ 3 + 1];

    long    descriptionIND;
    char    description[ 70 + 1 ];

    // decimal(6,4)
    long    drg_weightIND;
	char	drg_weight[ 12 + 1 ]; 

    long    runidIND;
	long    runid; 

    struct tagBuf2() {

        //drgIND = SQL_NULL_DATA;
        //drg[0] = '\0';

        strcpy( drg, "123" );
        drgIND = (long) strlen( drg );

        const char *DESCRIPTION = "This is a description of some sort. Testing";

        descriptionIND = (long) strlen( DESCRIPTION );
        strcpy( description, DESCRIPTION );

        strcpy( drg_weight, "12.42" );
        drg_weightIND = (long) strlen( drg_weight );

        runid = 15;
        runidIND = sizeof(long);
    }

} BUF2;


enum { MPCNO_SZ = 2 };
enum { MPCDESC_SZ = 100 };

#pragma pack( push, 1 )
typedef struct tagBuf3 {

    char    chFiller[8];

    long    mpcnoIND;
    char    mpcno[ MPCNO_SZ + 1];

    long    mpcdescIND;
    char    mpcdesc[ MPCDESC_SZ + 1 ];

    char    filler[ 2 ];

    struct tagBuf3() {

        mpcnoIND = SQL_NULL_DATA;
        mpcno[0] = '\0';

        mpcdescIND = SQL_NULL_DATA;
        mpcdesc[0] = '\0';
    }

} BUF3;

#pragma pack( pop )

enum { CMP_TYPE_CD_SZ = 8 };
enum { DESCRIPTION_SZ = 30 };
enum { CTRL_USR_ID_SZ = 128 };

#pragma pack( push, 1 )
typedef struct tagBuf4 {

    char    chFiller[8];

    long    cmp_type_cdIND;
    char    cmp_type_cd[ CMP_TYPE_CD_SZ + 1];

    long    descriptionIND;
    char    description[ DESCRIPTION_SZ + 1 ];

    long                ctrl_ins_dtmIND;
    TIMESTAMP_STRUCT    ctrl_ins_dtm;

    long                ctrl_upd_dtmIND;
    TIMESTAMP_STRUCT    ctrl_upd_dtm;

    long    ctrl_usr_idIND;
    char    ctrl_usr_id[ CTRL_USR_ID_SZ + 1 ];

    char    extra[8];

    struct tagBuf4() {

        memset(chFiller, 0, sizeof(tagBuf4));

        cmp_type_cdIND = SQL_NULL_DATA;
        cmp_type_cd[0] = '\0';

        descriptionIND = SQL_NULL_DATA;
        description[0] = '\0';

        ctrl_upd_dtmIND = SQL_NULL_DATA;
        memset( &ctrl_upd_dtm, 0, sizeof( ctrl_upd_dtm ) );

        ctrl_ins_dtmIND = SQL_NULL_DATA;
        memset( &ctrl_ins_dtm, 0, sizeof( ctrl_ins_dtm ) );

        ctrl_usr_idIND  = SQL_NULL_DATA;
        ctrl_usr_id[0]  = '\0';
    }

} BUF4;

#pragma pack( pop )


//#pragma pack( push, 1 )

typedef struct tagRoute {

	char    chFiller[8];

    long    rt_idIND;
    long	rt_id;

	long				rt_arrive_atIND;
	TIMESTAMP_STRUCT    rt_arrive_at;

	char	junk[4];

} ROUTE;

//#pragma pack( pop )


// CChildView window

class CChildView : public CWnd {

// Construction
public:
	CChildView();

// Attributes
public:

protected:

    BUF m_baseRow;    


    CListBox    m_lb;

// Operations
public:

// Overrides
	protected:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);

// Implementation
public:
	virtual ~CChildView();

	// Generated message map functions
protected:

    typedef struct tagTestMT {

        SQLHENV     henv;    
        SQLHDBC     hdbc;

        CChildView *pView;

    } TEST_MT;

    static UINT TestSQLTablesMTProc( LPVOID param );
	static UINT TestSQLAllocStmtMTProc( LPVOID param );

	afx_msg void OnPaint();

    SQLRETURN Connect( SQLHENV  &henv,
                       SQLHDBC  &hdbc,
                       const char *szConnect );

    SQLRETURN Disconnect( SQLHENV  &henv,
                          SQLHDBC  &hdbc );

    SQLRETURN TestBindOffset( SQLHENV  &m_henv,
                          SQLHDBC  &hdbc,
                          SQLHSTMT &hstmt );

    SQLRETURN TestBindParamOffsetPtrInsert( SQLHENV  &henv,
                                            SQLHDBC  &hdbc,
                                            SQLHSTMT &hstmt );

    SQLRETURN TestBindParamOffsetPtrInsert2( SQLHENV  &henv,
                                             SQLHDBC  &hdbc,
                                             SQLHSTMT &hstmt,
                                             const bool bBindOffset );

    SQLRETURN TestBindParamOffsetPtrInsert3( SQLHENV  &henv,
                                             SQLHDBC  &hdbc,
                                             SQLHSTMT &hstmt,
                                             const bool bBindOffset );

	void TestUpdateTimeStamp( const bool bBindOffset );
	SQLRETURN TestUpdateTimeStamp( SQLHENV  &henv,
                                   SQLHDBC  &hdbc,
                                   SQLHSTMT &hstmt,
								   const bool bBindOffset );

    void Testparameterbindoffsetinsert( const bool bBindOffset,
                                        const UINT nTest );

    SQLRETURN TestSQLTables( SQLHENV  &m_henv,
                             SQLHDBC  &hdbc,
                             const char *szTableCat,
                             const char *szTableSchem,
					         const char *szTableName,
                             const char *szTableType,
                             DWORD &cRow,
                             const bool bRowBindOffset = false );

	SQLRETURN ExecuteSQLProcedureColumns( SQLHSTMT hstmt,
										  const TCHAR *szProcedureCat,
										  const TCHAR *szProcedureSchem,
										  const TCHAR *szProcedureName );

	SQLRETURN TestSQLAllocStmt( SQLHENV  &henv,
                                SQLHDBC  &hdbc );

    template< typename T > SQLRETURN FetchRows( SQLHSTMT &hstmt,
                         DWORD &cFetched,
                         T *pRowBind,
                         SQLUINTEGER &nRowBindOffset,
                         vector< T > &vRow,
                         const bool bRowBindOffset = true );

    SQLRETURN FetchNextRow( HSTMT &hstmt );

    RETCODE DiagSQLError( SQLHENV  henv, 
                        SQLHDBC  hdbc, 
                        SQLHSTMT hstmt,
                        const SQLRETURN rc,
                        const char *ROUTINE,
                        const char *szContext = NULL );

	void GetLastError( const char *szCaption,  
			           const char *szRoutine );

    SQLRETURN SetAutoCommit( SQLHDBC hdbc, const bool bAutoCommit );

    afx_msg void OnTestTestparameterbindoffsetsequential();
    afx_msg void OnUpdateTestTestparameterbindoffsetsequential(CCmdUI *pCmdUI);
    afx_msg void OnTesttabletypes();
    afx_msg void OnUpdateTesttabletypes(CCmdUI *pCmdUI);

    void TestSQLTables( const bool bRowBindOffset );

    void TestSQLTablesMT();

    void TestGarbledCharData( const bool bParamBindOffset );

    SQLRETURN TestGarbledCharData( SQLHENV  &m_henv,
                                   SQLHDBC  &hdbc,
                                   DWORD &cRow,
                                   const bool bRowBindOffset = false );

    BOOL CreateThreadSuspend( CWinThread *pThread,
                              const bool bAutoDelete,
                              int nPriority = THREAD_PRIORITY_NORMAL,
                              UINT nStackSize = 0,
                              DWORD dwCreateFlags = 0,
                              LPSECURITY_ATTRIBUTES lpSecurityAttrs = NULL );

	void TestConnect();

    DECLARE_MESSAGE_MAP()

//    virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
    afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
    afx_msg void OnTestTestparameterbindoffsetinsert();
    afx_msg void OnUpdateTestTestparameterbindoffsetinsert(CCmdUI *pCmdUI);
    afx_msg void OnTestTestwithoutparameterbindoffset();
    afx_msg void OnUpdateTestTestwithoutparameterbindoffset(CCmdUI *pCmdUI);
    afx_msg void OnTestTestparameterlongerror();
    afx_msg void OnUpdateTestTestparameterlongerror(CCmdUI *pCmdUI);

    afx_msg void OnTestTestparameterlongerrornobindoffsetpointer();
    afx_msg void OnUpdateTestTestparameterlongerrornobindoffsetpointer(CCmdUI *pCmdUI);

    afx_msg void OnTestSQLTablesWithRowoffsetpointer();
    afx_msg void OnUpdateTestSQLTablesWithRowOffsetPointer(CCmdUI *pCmdUI);

    afx_msg void OnTestSQLTablesWithoutrowoffsetpointer();
    afx_msg void OnUpdateTestSQLTtablesWithoutrowoffsetpointer(CCmdUI *pCmdUI);
public:
    afx_msg void OnTestTestsqltablemulti();
    afx_msg void OnUpdateTestTestsqltablemulti(CCmdUI *pCmdUI);
    afx_msg void OnTestRuntest();
    afx_msg void OnUpdateTestRuntest(CCmdUI *pCmdUI);
    afx_msg void OnTest2();
    afx_msg void OnUpdateTest2(CCmdUI *pCmdUI);
};

